<?php if (!defined('PATH')) { exit; } ?>
<!DOCTYPE html>
<html lang="<?php echo $this->LANG; ?>" dir="<?php echo $this->DIR; ?>">
	<head>
    <meta charset="<?php echo $this->CHARSET; ?>">
    <meta property="x-header-csrf" content="<?php echo $this->CSRF_TOKEN; ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <title><?php echo $this->TITLE; ?></title>

    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/bootstrap.css" rel="stylesheet">
    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/theme.css" rel="stylesheet">
    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/font-awesome/font-awesome.css" rel="stylesheet">

    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/jquery-ui.css" rel="stylesheet">
    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/fam-icons.css" rel="stylesheet">
    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/plugins.css" rel="stylesheet">
    <link href="<?php echo $this->SYS_BASE_HREF; ?>css/mobile.css" rel="stylesheet">

    <link rel="icon" href="<?php echo $this->SYS_BASE_HREF; ?>images/favicon.ico">

	</head>

	<body>
	
	<?php
  // MOBILE HEADER
  // Shows only on extra small screens
  ?>
  <div class="mobiletopbar visible-xs push">
    <div>
     <i class="fa fa-<?php echo ($this->LOAD_OFF_CANVAS_MENU == 'yes' ? 'bars fa-fw menu-btn' : ($this->LOGGED_IN == 'yes' ? 'lock fa-fw nocanvas' : 'life-ring fa-fw nocanvas')); ?>"></i>
    </div>
    <div class="website">
      <a href="<?php echo $this->SETTINGS->scriptpath; ?>/<?php echo ($this->LOGGED_IN == 'yes' ? '?p=dashboard' : ''); ?>"><?php echo $this->TOP_BAR_TITLE; ?></a>
    </div>
    <div>
     <div class="btn-group">
        <button type="button" class="btn btn-sm btn-info dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          <i class="fa fa-chevron-down fa-fw"></i>
        </button>
        <ul class="dropdown-menu dropdown-menu-right">
          <?php
          // Is user logged in?
          if ($this->LOGGED_IN == 'yes') {
          ?>
          <li><a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=dashboard"><i class="fa fa-dashboard fa-fw"></i> <?php echo $this->TXT[2]; ?></a></li>
          <?php
          // Show if FAQ is enabled...
          if ($this->SETTINGS->kbase == 'yes') {
          ?>
          <li><a href="<?php echo $this->SETTINGS->scriptpath; ?>/"><i class="fa fa-question-circle fa-fw"></i> <?php echo $this->TXT[0]; ?></a></li>
          <?php
          }
          } else {
          ?>
          <li><a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=open" rel="nofollow"><i class="fa fa-pencil fa-fw"></i> <?php echo $this->TXT[1]; ?></a></li>
          <?php
          // Is account creation enabled?
          if ($this->SETTINGS->createAcc == 'yes') {
          ?>
          <li><a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=create" rel="nofollow"><i class="fa fa-user fa-fw"></i> <?php echo $this->TXT[8]; ?></a></li>
          <?php
          }
          ?>
          <li><a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=login" rel="nofollow"><i class="fa fa-sign-in fa-fw"></i> <?php echo $this->TXT[4]; ?></a></li>
          <?php
          }
          ?>
        </ul>
      </div>
    </div>
  </div>
    
  <?php
  // STANDARD HEADER
  // Shows on larger screens
  ?>
  <div class="navbar push hidden-xs">
    <div class="navbar-inner">
      <div class="container">
        <div class="pull-right">
          <?php
          // Is user logged in?
          if ($this->LOGGED_IN == 'yes') {
          ?>
          <a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=dashboard"><i class="fa fa-dashboard fa-fw"></i> <?php echo $this->TXT[2]; ?></a>
          <?php
          // Show if FAQ is enabled...
          if ($this->SETTINGS->kbase == 'yes') {
          ?>
          <a href="<?php echo $this->SETTINGS->scriptpath; ?>/"><i class="fa fa-question-circle fa-fw"></i> <?php echo $this->TXT[0]; ?></a>
          <?php
          }
          } else {
          ?>
          <a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=open" rel="nofollow"><i class="fa fa-pencil fa-fw"></i> <?php echo $this->TXT[1]; ?></a>
          <?php
          // Is account creation enabled?
          if ($this->SETTINGS->createAcc == 'yes') {
          ?>
          <a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=create" rel="nofollow"><i class="fa fa-user fa-fw"></i> <?php echo $this->TXT[8]; ?></a>
          <?php
          }
          ?>
          <a href="<?php echo $this->SETTINGS->scriptpath; ?>/?p=login" rel="nofollow"><i class="fa fa-sign-in fa-fw"></i> <?php echo $this->TXT[4]; ?></a>
          <?php
          }
          ?>
        </div>
        <i class="fa fa-<?php echo ($this->LOAD_OFF_CANVAS_MENU == 'yes' ? 'bars fa-fw menu-btn' : ($this->LOGGED_IN == 'yes' ? 'lock fa-fw nocanvas' : 'life-ring fa-fw nocanvas')); ?>"></i> <span><a href="index.php"><?php echo $this->TOP_BAR_TITLE; ?></a></span>
      </div>
    </div>
  </div>